function scatt=apply_scattering(mesh,sigmas,u)
%assume sigmas a function handle that is pcw constant on the I_z for all elements I_z x I_mu.
mean_u=zeros(size(mesh.zf_ip)); % contains mu-integrals of u in common finest partition integration points.
u=reshape(u,mesh.no_basis_mu*mesh.no_basis_z,size(mesh.elem,2));
for it=1:size(mesh.elem,2)
    l=mesh.elem(5,it);
    h=1/2^l; % note this h is for both, z and mu, currently, i.e., L=1
    [i,j]=ind2sub([2^l,2^l],mesh.elem(6,it));
    z_l=(i-1)*h;z_r= i*h;
    % find all integration points zf_ip in (z_l, z_r)
    ind=(z_l<mesh.zf_ip)&(mesh.zf_ip<z_r);
    x_back = (mesh.zf_ip-z_l)/h;% transform integration points back to (0,1) in order to evaluate in basis.

    uh=0;
    u_coord=u(:,it);
    u_coord=reshape(u_coord,mesh.no_basis_mu,mesh.no_basis_z);
    for i=1:mesh.no_basis_z
        uh=uh+u_coord(1,i)*mesh.phi{i}(x_back(ind));
    end
    mean_u(ind)=mean_u(ind)+h*uh; %integrate in mu direction for each integration point in finest z partition.
end

% compute local contribution of scattering integral
% integrate mean_u against basis per element,
% which evaluates the scattering operator
scatt=zeros(mesh.no_basis_z*mesh.no_basis_mu,size(mesh.elem,2));
for it=1:size(mesh.elem,2)
    l=mesh.elem(5,it);
    h=1/2^l; % note this h is for both, z and mu, currently, i.e., L=1
    [i,j]=ind2sub([2^l,2^l],mesh.elem(6,it));
    
    z_l=(i-1)*h;
    z_r= i*h;
    
    ind=find((z_l<mesh.zf_ip(1,:))&(mesh.zf_ip(1,:)<z_r)); % which integration points fall into local I_z
    x_back = (mesh.zf_ip(:,ind)-z_l)/h;% transform integration points back to (0,1) in order to evaluate in basis.
    
    dz=diff(mesh.zf);
    
    scatt_loc=zeros(mesh.no_basis_mu,mesh.no_basis_z);
        for i=1:mesh.no_basis_z
            scatt_loc(1,i)= h * sum( mesh.w'*(sigmas(mesh.zf_ip(:,ind)).*dz(ind).*mean_u(:,ind).*mesh.phi{i}(x_back)));
        end
        scatt(:,it)=scatt_loc(:);
end
scatt=scatt(:);
end