function [approx_err_L2,approx_err_L2_unsc,interp_err_L2,approx_err_derivative,approx_err_derivative_unsc,interp_err_derivative]=compute_errors(u,Ihu,ux,dux,elem,x,w,xc,wc,phi,dphi,no_basis_z,no_basis_mu)
approx_err_L2=zeros(size(elem,2),1);
approx_err_derivative=approx_err_L2;
interp_err_L2=approx_err_L2;
interp_err_derivative=interp_err_L2;
approx_err_L2_unsc=approx_err_L2;
approx_err_derivative_unsc=approx_err_L2_unsc;
for it=1:size(elem,2)
    l=elem(5,it);
    h=1/2^l;
    [i,j]=ind2sub([2^l,2^l],elem(6,it));

    z_l=(i-1)*h;
    mu_b=(j-1)*h;
    mu_ip = h*xc+mu_b; % transform integration points from (0,1) to (mu_b,mu_t)
    z_ip = h*x+ z_l; % transform integration points from (0,1) to (z_l,z_r)

    uh_loc=zeros(length(x),length(xc));
    duh_loc=zeros(length(x),length(xc));
    Iuh_loc=zeros(length(x),length(xc));
    dIuh_loc=zeros(length(x),length(xc));
    u_coord=reshape(u(:,it),no_basis_mu,no_basis_z);
    Ihu_coord=reshape(Ihu(:,it),no_basis_mu,no_basis_z);
    for j=1:no_basis_mu
        for i=1:no_basis_z
            uh_loc=uh_loc    + u_coord(j,i)   * phi{i}(x)*phi{j}(xc');
            duh_loc=duh_loc  + u_coord(j,i)   *dphi{i}(x)/h*phi{j}(xc');
            Iuh_loc=Iuh_loc  + Ihu_coord(j,i) * phi{i}(x)*phi{j}(xc');
            dIuh_loc=dIuh_loc+ Ihu_coord(j,i) *dphi{i}(x)/h*phi{j}(xc');
        end
    end
    approx_err_L2(it)   = h^2* w'*(ux(z_ip,mu_ip')-uh_loc).^2*wc;
    approx_err_L2_unsc(it)        =      w'*(ux(z_ip,mu_ip')-uh_loc).^2*wc;
    interp_err_L2(it)   = h^2* w'*(ux(z_ip,mu_ip')-Iuh_loc).^2*wc;
    approx_err_derivative(it) = h^2* w'*(dux(z_ip,mu_ip')-duh_loc).^2*(mu_ip.^2.*wc);
    approx_err_derivative_unsc(it) =  w'*(dux(z_ip,mu_ip')-duh_loc).^2*(mu_ip.^2.*wc);
    interp_err_derivative(it) =h^2* w'*(dux(z_ip,mu_ip')-dIuh_loc).^2*(mu_ip.^2.*wc);
end
