function [edge2elem,int_edges]=edge_to_elem(elem,nodes,edges)
%% create edge to element mapping
hmin=(1/2).^max(elem(5,:)); %smallest h.
edge2elem=zeros(2,size(edges,2));
for it=1:size(edges,2)
    n1=edges(1,it);
    n2=edges(2,it);
    mid=0.5*(nodes(:,n1)+nodes(:,n2));
    point_left=mid - 0.5*hmin*[1;0];
    if point_left(1)<0 % boundary edge
        left_elem=-1;
    else
        for l=max(elem(5,:)):-1:0
            h=1/2^l;
            i=floor(point_left(1)/h)+1;
            j=floor(point_left(2)/h)+1;
            k=sub2ind([2^l,2^l],i,j);
            ind=find(ismember(elem(5:6,:)',[l,k],'rows'));
            if ~isempty(ind)
                left_elem=ind;
                break
            end
        end
    end
    point_right=mid + 0.5*hmin*[1;0];
    if point_right(1)>1 % boundary edge
        right_elem=-1;
    else
        for l=max(elem(5,:)):-1:0
            h=1/2^l;
            i=floor(point_right(1)/h)+1;
            j=floor(point_right(2)/h)+1;
            k=sub2ind([2^l,2^l],i,j);
            ind=find(ismember(elem(5:6,:)',[l,k],'rows'));
            if ~isempty(ind)
                right_elem=ind;
                break
            end
        end
    end
    edge2elem(1,it)=left_elem;
    edge2elem(2,it)=right_elem;
end
int_edges=find((edge2elem(1,:)>0)&(edge2elem(2,:)>0)); %interior faces
end