function Ihu=getInterpolant(u,elem,x,w,xc,wc,phi,no_basis_z,no_basis_mu)
% compute the L2-projection Ihu of u.
Ihu=zeros(no_basis_z*no_basis_mu,size(elem,2));
% loop over all elements
for it=1:size(elem,2)
    l=elem(5,it);
    h=1/2^l;
    [i,j]=ind2sub([2^l,2^l],elem(6,it));
    z_l=(i-1)*h;
    mu_b=(j-1)*h;
    x_m=h*x+z_l;        % map integration points to I_z
    mu_ip=h*xc+mu_b;    % map integration points to I_mu
    Ihu_loc=zeros(no_basis_mu,no_basis_z);
    u_ip=u(x_m,mu_ip'); % evaluate u in integration points
    for i=1:no_basis_z
        for j=1:no_basis_mu
            Ihu_loc(j,i)= (w.*phi{i}(x))'*u_ip*(wc.*phi{j}(xc));
        end
    end
    Ihu(:,it)=Ihu_loc(:);
end
