function [errIndL2,errIndH1weighted]=hierarchical_h(uc,uf,no_basis_z,no_basis_mu,elem,phi,dphi,x,w,xc,wc,extra_z,extra_mu)

errIndL2=zeros(size(elem,2),1);
errIndH1weighted=errIndL2;
% error=0*uf;
for it=1:size(elem,2)
    l=elem(5,it);
    h=1/2^l;
    [i,j]=ind2sub([2^l,2^l],elem(6,it));
    mu_b=(j-1)*h;
    mu_ip_bot = (h/2*xc+mu_b)'; % transform integration points from (0,1) to (mu_b,mu_b+h/2)
    mu_ip_top = (h/2*xc+h/2+mu_b)'; % transform integration points from (0,1) to (mu_b+h/2,mu_t)
    uc_coord=zeros(no_basis_mu+extra_mu,no_basis_z+extra_z);
    uc_coord(1:no_basis_mu,1:no_basis_z)=reshape(uc(:,it),no_basis_mu,no_basis_z);
    uf1_coord=reshape(uf(:,4*(it-1)+1),no_basis_mu+extra_mu,no_basis_z+extra_z); % bottom left
    uf2_coord=reshape(uf(:,4*(it-1)+2),no_basis_mu+extra_mu,no_basis_z+extra_z); % bottom right
    uf3_coord=reshape(uf(:,4*(it-1)+3),no_basis_mu+extra_mu,no_basis_z+extra_z); % top right
    uf4_coord=reshape(uf(:,4*(it-1)+4),no_basis_mu+extra_mu,no_basis_z+extra_z); % top left
    
    % L2 error contribution int_elem |uc-uf|^2
    % integrate over 4 sub elements: bottom left, bottom right, top right,
    % top left
    % initialize local error contributions
    err1_loc=zeros(length(x),length(xc));
    err2_loc=zeros(length(x),length(xc));
    err3_loc=zeros(length(x),length(xc));
    err4_loc=zeros(length(x),length(xc));
    % evaluate integrand in the integration points
    for j=1:no_basis_mu
        for i=1:no_basis_z
            err1_loc=err1_loc  + uc_coord(j,i)*phi{i}(x/2)*phi{j}(xc'/2)            - uf1_coord(j,i)*phi{i}(x)*phi{j}(xc'); % bottom left
            err2_loc=err2_loc  + uc_coord(j,i)*phi{i}(x/2+1/2)*phi{j}(xc'/2)        - uf2_coord(j,i)*phi{i}(x)*phi{j}(xc'); % bottom right
            err3_loc=err3_loc  + uc_coord(j,i)*phi{i}(x/2+1/2)*phi{j}(xc'/2 + 1/2)  - uf3_coord(j,i)*phi{i}(x)*phi{j}(xc'); % top right
            err4_loc=err4_loc  + uc_coord(j,i)*phi{i}(x/2)*phi{j}(xc'/2 + 1/2)      - uf4_coord(j,i)*phi{i}(x)*phi{j}(xc'); % top left
        end
    end
    % integrate
    errIndL2(it)=  (h/2)^2*(w'*(err1_loc.^2+err2_loc.^2+err3_loc.^2+err4_loc.^2)*wc);
    
    % dz^h error contribution int_elem |dz^h(uc-uf)|^2
    % integrate over 4 sub elements
    % initialize error contributions
    derr1_loc=zeros(length(x),length(xc));
    derr2_loc=zeros(length(x),length(xc));
    derr3_loc=zeros(length(x),length(xc));
    derr4_loc=zeros(length(x),length(xc));
    % evaluate integrand in integration points
    for j=1:no_basis_mu
        for i=1:no_basis_z
            derr1_loc=derr1_loc  + uc_coord(j,i)*dphi{i}(x/2)/h*phi{j}(xc'/2)            - uf1_coord(j,i)*dphi{i}(x)/(h/2)*phi{j}(xc'); % bottom left
            derr2_loc=derr2_loc  + uc_coord(j,i)*dphi{i}(x/2+1/2)/h*phi{j}(xc'/2)        - uf2_coord(j,i)*dphi{i}(x)/(h/2)*phi{j}(xc'); % bottom right
            derr3_loc=derr3_loc  + uc_coord(j,i)*dphi{i}(x/2+1/2)/h*phi{j}(xc'/2 + 1/2)  - uf3_coord(j,i)*dphi{i}(x)/(h/2)*phi{j}(xc'); % top right
            derr4_loc=derr4_loc  + uc_coord(j,i)*dphi{i}(x/2)/h*phi{j}(xc'/2 + 1/2)      - uf4_coord(j,i)*dphi{i}(x)/(h/2)*phi{j}(xc'); % top left
        end
    end
    % integrate
    errIndH1weighted(it)=  (h/2)^2*(w'*(derr1_loc.^2.*mu_ip_bot.^2+derr2_loc.^2.*mu_ip_bot.^2+derr3_loc.^2.*mu_ip_top.^2+derr4_loc.^2.*mu_ip_top.^2)*wc);
%     errIndH1weighted(it) = h^2* w'*derr_loc.^2*(mu_ip.^2.*wc);

end