function [errIndL2,errIndH1weighted,err_ind_edges]=hierarchical_p(uc,uf,no_basis_z,no_basis_mu,elem,nodes,edges,edge2elem,int_edges,Jmp,HF,phi,dphi,x,w,xc,wc,extra_z,extra_mu)

errIndL2=zeros(size(elem,2),1);
errIndH1weighted=errIndL2;
error=0*uf;
for it=1:size(elem,2)
    l=elem(5,it);
    h=1/2^l;
    [i,j]=ind2sub([2^l,2^l],elem(6,it));
    mu_b=(j-1)*h;
    mu_ip = h*xc+mu_b; %transform integration points from (0,1) to (mu_b,mu_t)
    uc_coord=zeros(no_basis_mu+extra_mu,no_basis_z+extra_z);
    uc_coord(1:no_basis_mu,1:no_basis_z)=reshape(uc(:,it),no_basis_mu,no_basis_z);
    uf_coord=reshape(uf(:,it),no_basis_mu+extra_mu,no_basis_z+extra_z);
    err_coord=uc_coord-uf_coord;
    error(:,it)=err_coord(:);
    errIndL2(it) = sum(sum(err_coord.^2))*h^2; % L2-norm

    derr_loc=zeros(length(x),length(xc));
    for j=1:no_basis_mu+extra_mu
        for i=1:no_basis_z+extra_z
            derr_loc=derr_loc  + err_coord(j,i)   * dphi{i}(x)/h*phi{j}(xc');
        end
    end
    errIndH1weighted(it) = h^2* w'*derr_loc.^2*(mu_ip.^2.*wc);
end
% 
err=uf;
err=reshape(err,(no_basis_mu+extra_mu)*(no_basis_z+extra_z),size(elem,2));
err(1:no_basis_z*no_basis_mu,:)=err(1:no_basis_z*no_basis_mu,:)-reshape(uc,no_basis_mu*no_basis_z,size(elem,2));
Jerr=Jmp*err(:); % jumps of err
Jerr=reshape(Jerr,no_basis_mu+extra_mu,size(int_edges,2));
% % Jf=0*Ju;
% % Jf=Jmp*(L2\(iflux*u)); % jumps of flux (QL2*(UL2\(LL2\(PL2*iflux))
bnd_edges=setdiff(1:size(edges,2),int_edges);
err_ind_edges=0*errIndH1weighted;
% contribution from the jumps of internal edges
for it=1:length(int_edges)
    el_l=edge2elem(1,int_edges(it));
    el_r=edge2elem(2,int_edges(it));
    n1=edges(1,int_edges(it));
    n2=edges(2,int_edges(it)); % node indices describing face
    hF=norm(nodes(:,n1)-nodes(:,n2)); % face length
%     h_l=1/2^elem(5,el_l); % mesh size of the element to the left
%     h_r=1/2^elem(5,el_r); % mesh size fo the element to the right
%     hF=min(h_l,h_r);
    mu_b=min(nodes(2,[n1 n2]));
    mu_ip = hF*xc(:)+mu_b; %transform integration points from (0,1) to (mu_b,mu_t)

    Jerr_ip = 0;
    for i=1:no_basis_mu+extra_mu
        Jerr_ip = Jerr_ip + Jerr(i,it)*phi{i}(xc);
    end
    err_ind_edges(el_l)=err_ind_edges(el_l)+(hF*wc'*(Jerr_ip.^2.*mu_ip))/2/HF(it); % 
    err_ind_edges(el_r)=err_ind_edges(el_r)+(hF*wc'*(Jerr_ip.^2.*mu_ip))/2/HF(it); % 
end
for it=1:length(bnd_edges)
    el_l=edge2elem(1,bnd_edges(it));
    el_r=edge2elem(2,bnd_edges(it));
    n1=edges(1,bnd_edges(it));
    n2=edges(2,bnd_edges(it)); % node indices describing face
    hF=norm(nodes(:,n1)-nodes(:,n2)); % face length
    mu_b=min(nodes(2,[n1 n2]));
    mu_ip = hF*xc(:)+mu_b; %transform integration points from (0,1) to (mu_b,mu_t)
    if el_l == -1 % left bdry
        idx=el_r;
        zb=0;
    else % right bdry
        idx=el_l;
        zb=1;
    end
    
    Jerr_ip = 0;
    err_coord=reshape(err(:,idx),no_basis_mu+extra_mu,no_basis_z+extra_z);
    for j=1:no_basis_mu+extra_mu
        for i=1:no_basis_z+extra_z
            Jerr_ip=Jerr_ip  + err_coord(j,i)   * phi{i}(zb)*phi{j}(xc);
        end
    end
    err_ind_edges(idx)=err_ind_edges(idx)+(hF*wc'*(Jerr_ip.^2.*mu_ip)); % 
end
% 
% 
