function [phi,dphi]=load_basis_functions()
% shifted and normalized Legendre polynomials for (0,1)
phi{1}=@(x)0*x+1;
phi{2}=@(x)sqrt(3)*(2*x-1);
phi{3}=@(x)sqrt(5)*(6*x.^2-6*x+1);
phi{4}=@(x)sqrt(7)*(20*x.^3-30*x.^2+12*x-1);
phi{5}=@(x)sqrt(9)*(70*x.^4-140*x.^3+90*x.^2-20*x+1);
phi{6}=@(x)sqrt(11)*(252*x.^5-630*x.^4+560*x.^3-210*x.^2+30*x-1);

% derivatives of basis functions
dphi{1}=@(x)0*x;
dphi{2}=@(x)sqrt(3)*(2+0*x);
dphi{3}=@(x)sqrt(5)*(12*x-6);
dphi{4}=@(x)sqrt(7)*(60*x.^2-60*x+12);
dphi{5}=@(x)sqrt(9)*(280*x.^3-420*x.^2+180*x-20);
dphi{6}=@(x)sqrt(11)*(1260*x.^4-2520*x.^3+1680*x.^2-420*x+30);
end